#!/system/bin/sh

supolicy --live "permissive audioserver dolby_prop dts_data_file hal_audio_default priv_app servicemanager system_server"

# (
  # supolicy --live "create dolby_prop dts_data_file"
  # supolicy --live "allow dts_data_file labeledfs filesystem *"
  # supolicy --live "allow audioserver default_android_service service_manager *"
  # supolicy --live "allow audioserver dts_data_file dir *"
  # supolicy --live "allow audioserver { dts_data_file sysfs } file *"
  # supolicy --live "allow audioserver hal_broadcastradio_hwservice hwservice_manager *"
  # supolicy --live "allow hal_audio_default audioserver_service service_manager *"
  # supolicy --live "allow hal_audio_default dolby_prop file *"
  # supolicy --live "allow hal_audio_default hal_audio_default process *"
  # supolicy --live "allow hal_audio_default servicemanager binder *"
  # supolicy --live "allow priv_app init unix_stream_socket *"
  # supolicy --live "allow priv_app property_socket sock_file *"
  # supolicy --live "allow servicemanager hal_audio_default dir *"
  # supolicy --live "allow servicemanager hal_audio_default file *"
  # supolicy --live "allow servicemanager hal_audio_default process *"
  # supolicy --live "allow system_server { audioserver hal_audio_default } file *"
# )&


dts=/data/misc/dts
if [ ! -d "$dts" ]; then

  mkdir -p $dts
  chmod 0775 $dts
  chown 1013.1005 $dts
  
elif [ "$(ls $dts)" ]; then

  for dtsfile in $dts/*; do
      chmod 0644 $dtsfile
      chown 1041.1005 $dtsfile
  done
  
fi
chcon -R u:object_r:dts_data_file:s0 $dts

dolby=/data/misc/dolby
if [ ! -d "$dolby" ]; then

  mkdir -p $dolby
  chmod 0775 $dolby
  chown 1013.1005 $dolby
  
elif [ "$(ls $dolby)" ]; then

  for dolbyfile in $dolby/*; do
    chmod 0644 $dolbyfile
    chown 1041.1005 $dolbyfile
  done
  
fi
chcon -R u:object_r:dts_data_file:s0 $dolby


if [ ! -d "$ROOT/odm" ]; then

  mkdir -p $ROOT/odm/etc
  chmod 0755 $ROOT/odm $ROOT/odm/etc
  chown 1000.1000 $ROOT/odm $ROOT/odm/etc
  chcon -R u:object_r:system_file:s0 $ROOT/odm

  if [ -d "$VEN/etc/audio" ]; then
    AP="$(find -L $VEN/etc/audio -type f -name "audio_policy_configuration*.xml" | head -n 1)"
    APDIR=$VEN/etc
  else
    AP="$(find -L $SYS/etc -type f -name "audio_policy_configuration*.xml" | head -n 1)"
    APDIR=$SYS/etc
  fi
  
  POLS="$(find -L $APDIR -type f -name "audio_policy_configuration*.xml") $(grep "include href=" $AP | sed -r "s|.*=\"(.*)\".*|$APDIR/\1|g")"
  for POL in ${POLS}; do
    [ -f "$POL" ] && ln -sf $POL $ROOT/odm/etc/
  done
  
fi

exit 0

